#!/usr/bin/perl

use Socket;
use strict;

my ( $PORT, $QTYPE, $QCLASS ) = ( 53, 1, 1 );

@ARGV == 3 or die "usage: dnss.add.pl <remote ip> <dns_name> <ip for dns_name>\n";
my ( $remote_ip, $dns_name, $ip ) = @ARGV;

socket( SOCK, PF_INET, SOCK_DGRAM, 0 ) or die "error: socket\n";

$dns_name = ( join '', map {  pack('C',length $_) . $_ } split /\./, $dns_name ) . "\x00";

my $id = int( rand( 10240 ) );
my $data =
	pack( 'nn', $id, 0x1234 ).
	pack( 'nnnn', 0, 1, 0, 0 ).
	$dns_name.
	pack( 'nn', $QTYPE, $QCLASS ) .
	pack( 'N', 3600 ) .		# TTL (seconds)
	pack( 'n', 4 ) . 		# 4 octets for RDATA
	pack( 'C4', split /\./, $ip );

my $addr = inet_aton( $remote_ip ) or die "error: inet_aton: $!\n";
defined send( SOCK, $data, 0, sockaddr_in( $PORT, $addr ) ) or die "error: send\n";
exit 0;

print "sent\n";