# Return codes:
# 0 - sucess
# 1 - remote malfunction, service not up, answer garbled, other remote failures
# 2 - service up, no flag (not used for 'store') == corrupt
# 3 - internal error/local failure

use Socket;
use strict;

my $cmd;
my $id;
my $ip;
my $flag;
my $pass;
my $flaglen = 255;
my $data;

(@ARGV==5 || @ARGV==3) or die "Example: ./shop_checker.pl {flag|store|retreive} [IP] [ID] [FLAG] [PASS]\n";

if ($ARGV[0] eq "flag"){($cmd, $ip, $id)=@ARGV;}
else {($cmd, $ip,  $id, $flag, $pass)=@ARGV;}


flag() if $cmd eq "flag";
store() if $cmd eq "store";
retreive() if $cmd eq "retreive";

sub flag {

        local $/;
        open F, "shakespear.txt" or do {print "Can't open shakespear file: $!\n"; exit (3);};
        $_ = <F>;
        close F;
        my $m = substr($_, int(rand(length($_) - 256)), $flaglen);
        $m =~ s/(.)/int(rand(2))?lc($1):uc($1)/ge;
        print STDOUT $m."\n";
        exit(0);

}



sub store {


	socket SOCK, PF_INET, SOCK_STREAM, getprotobyname('tcp') or do {print "Can't open socket: $!\n"; exit (3);};
	my $addr=sockaddr_in(21, inet_aton("$ip"));
	connect SOCK, $addr or do {print "Can't connect: $!\n"; exit (1);};

	recv SOCK, $data, 1500, 0;
	debug ("\n\n".$data);
	exit (1) if $data!~/220 OneFTP Server/;


	send SOCK, "user $id\n", 0;
	recv SOCK, $data, 1500, 0;
	debug ($data);
	exit (1) if $data!~/331 Password required for/;


	send SOCK, "pass $pass\n", 0;
	recv SOCK, $data, 1500, 0;	
	debug ($data);
	exit (1) if $data!~/logged in/;


	send SOCK, "syst\n", 0;
	recv SOCK, $data, 1500, 0;	
	debug ($data);
	exit (1) if $data!~/215 Game image of III Ural CTF contest/;


	send SOCK, "pasv\n", 0;
	recv SOCK, $data, 1500, 0;	
	debug ($data);
	exit (1) if $data!~/227 Entering/;

	
	$data=~/(\d+),(\d+)\)/;
	my $port=$1*256+$2;
	
	my $pid=fork();

	if (!$pid){

		close SOCK;

		select undef, undef, undef, 0.25;

		socket PASV, PF_INET, SOCK_STREAM, getprotobyname('tcp') or do {print "Can't open socket: $!\n"; exit (3);};
		my $paddr=sockaddr_in($port, inet_aton("$ip"));
		connect PASV, $paddr or do {print "Can't connect: $!\n"; exit (1);};
		send PASV, "$flag\n", 0; 		
		close PASV;
		exit (0);
	}

	send SOCK, "stor $id"."_flag\n", 0;
	recv SOCK, $data, 1500, 0;
	debug ($data);
	exit (1) if $data!~/150 Opening BINARY mode data connection for/;
	
	recv SOCK, $data, 1500, 0;
	debug ($data);
	exit (1) if $data!~/226 Transfer compete/;

	close SOCK;

	retreive ();
	
}

sub retreive
{

	socket SOCK, PF_INET, SOCK_STREAM, getprotobyname('tcp') or do {print "Can't open socket: $!\n"; exit (3);};
	my $addr=sockaddr_in(21, inet_aton("$ip"));
	connect SOCK, $addr or do {print "Can't connect: $!\n"; exit (1);};

	recv SOCK, $data, 1500, 0;
	debug ("\n\n".$data);
	exit (1) if $data!~/220 OneFTP Server/;


	send SOCK, "user $id\n", 0;
	recv SOCK, $data, 1500, 0;
	debug ($data);
	exit (1) if $data!~/331 Password required for/;


	send SOCK, "pass $pass\n", 0;
	recv SOCK, $data, 1500, 0;	
	debug ($data);
	exit (1) if $data!~/logged in/;


	send SOCK, "syst\n", 0;
	recv SOCK, $data, 1500, 0;	
	debug ($data);
	exit (1) if $data!~/215 Game image of III Ural CTF contest/;

	send SOCK, "check $id"."_flag\n", 0;
	recv SOCK, $data, 1500, 0;
	debug ($data);
	exit (1) if $data!~/777 flag:/;

	close SOCK;
	
	exit (0) if $data=~/$flag/;
	exit (2);

}

sub debug {

	my $d=shift;
	open F, ">>ftp_debug.txt" or do {print "Can't open debug file: $!\n"; exit (3);};
	print F "For ip=$ip, id=$id, pass=$pass flag=$flag: $d";
	close F;
}
